com.io7m.jcanephora.renderstate

## Class JCGLCullingStateMutable

- java.lang.Object
- - com.io7m.jcanephora.renderstate.JCGLCullingStateMutable

- All Implemented Interfaces:
    JCGLCullingStateType

      @Generated(value={"Modifiables.generator","JCGLCullingStateType"})
      public final class JCGLCullingStateMutable
      extends Object
      implements JCGLCullingStateType

  A modifiable implementation of the `JCGLCullingStateType` type.

  Use the `create()` static factory methods to create new instances.

  JCGLCullingStateMutable is not thread-safe

  See Also:
    `JCGLCullingState`

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `JCGLCullingStateMutable` | `clear()` Clears the object by setting all attributes to their initial values.
    `static JCGLCullingStateMutable` | `create()` Construct a modifiable instance of `JCGLCullingStateType`.
    `static JCGLCullingStateMutable` | `create(JCGLFaceSelection faceSelection, JCGLFaceWindingOrder faceWindingOrder)` Construct a modifiable instance of `JCGLCullingStateType`.
    `boolean` | `equals(Object another)` This instance is equal to all instances of `JCGLCullingStateMutable` that have equal attribute values.
    `boolean` | `faceSelectionIsSet()` Returns `true` if the default attribute `faceSelection` is set.
    `boolean` | `faceWindingOrderIsSet()` Returns `true` if the default attribute `faceWindingOrder` is set.
    `JCGLCullingStateMutable` | `from(JCGLCullingStateType instance)` Fill this modifiable instance with attribute values from the provided `JCGLCullingStateType` instance.
    `JCGLFaceSelection` | `getFaceSelection()`
    `JCGLFaceWindingOrder` | `getFaceWindingOrder()`
    `int` | `hashCode()` Computes a hash code from attributes: `faceSelection`, `faceWindingOrder`.
    `boolean` | `isInitialized()` Returns `true` if all required attributes are set, indicating that the object is initialized.
    `JCGLCullingStateMutable` | `setFaceSelection(JCGLFaceSelection faceSelection)` Assigns a value to the `faceSelection` attribute.
    `JCGLCullingStateMutable` | `setFaceWindingOrder(JCGLFaceWindingOrder faceWindingOrder)` Assigns a value to the `faceWindingOrder` attribute.
    `JCGLCullingState` | `toImmutable()` Converts to `JCGLCullingState`.
    `String` | `toString()` Generates a string representation of this `JCGLCullingStateType`.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### create

          public static JCGLCullingStateMutable create(JCGLFaceSelection faceSelection,
                                                       JCGLFaceWindingOrder faceWindingOrder)

      Construct a modifiable instance of `JCGLCullingStateType`.
      Parameters:
        `faceSelection` - The value for the `faceSelection` attribute
        `faceWindingOrder` - The value for the `faceWindingOrder` attribute
      Returns:
        A new modifiable instance

    - #### create

          public static JCGLCullingStateMutable create()

      Construct a modifiable instance of `JCGLCullingStateType`.
      Returns:
        A new modifiable instance

    - #### getFaceSelection

          public final JCGLFaceSelection getFaceSelection()

      Specified by:
        `getFaceSelection` in interface `JCGLCullingStateType`
      Returns:
        The faces that will be culled

    - #### getFaceWindingOrder

          public final JCGLFaceWindingOrder getFaceWindingOrder()

      Specified by:
        `getFaceWindingOrder` in interface `JCGLCullingStateType`
      Returns:
        The face winding order

    - #### clear

          public JCGLCullingStateMutable clear()

      Clears the object by setting all attributes to their initial values.
      Returns:
        `this` for use in a chained invocation

    - #### from

          public JCGLCullingStateMutable from(JCGLCullingStateType instance)

      Fill this modifiable instance with attribute values from the provided `JCGLCullingStateType` instance. Regular attribute values will be overridden, i.e. replaced with ones of an instance. Any of the instance's absent optional values will not be copied (will not override current values).
      Parameters:
        `instance` - The instance from which to copy values
      Returns:
        `this` for use in a chained invocation

    - #### setFaceSelection

          public JCGLCullingStateMutable setFaceSelection(JCGLFaceSelection faceSelection)

      Assigns a value to the `faceSelection` attribute.

      If not set, this attribute will have a default value returned by the initializer of `faceSelection`.

      Parameters:
        `faceSelection` - The value for faceSelection
      Returns:
        `this` for use in a chained invocation

    - #### setFaceWindingOrder

          public JCGLCullingStateMutable setFaceWindingOrder(JCGLFaceWindingOrder faceWindingOrder)

      Assigns a value to the `faceWindingOrder` attribute.

      If not set, this attribute will have a default value returned by the initializer of `faceWindingOrder`.

      Parameters:
        `faceWindingOrder` - The value for faceWindingOrder
      Returns:
        `this` for use in a chained invocation

    - #### faceSelectionIsSet

          public final boolean faceSelectionIsSet()

      Returns `true` if the default attribute `faceSelection` is set.
      Returns:
        `true` if set

    - #### faceWindingOrderIsSet

          public final boolean faceWindingOrderIsSet()

      Returns `true` if the default attribute `faceWindingOrder` is set.
      Returns:
        `true` if set

    - #### isInitialized

          public final boolean isInitialized()

      Returns `true` if all required attributes are set, indicating that the object is initialized.
      Returns:
        `true` if set

    - #### toImmutable

          public final JCGLCullingState toImmutable()

      Converts to `JCGLCullingState`.
      Returns:
        An immutable instance of JCGLCullingState

    - #### equals

          public boolean equals(Object another)

      This instance is equal to all instances of `JCGLCullingStateMutable` that have equal attribute values.
      Overrides:
        `equals` in class `Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode()

      Computes a hash code from attributes: `faceSelection`, `faceWindingOrder`.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        hashCode value

    - #### toString

          public String toString()

      Generates a string representation of this `JCGLCullingStateType`. If uninitialized, some attribute values may appear as question marks.
      Overrides:
        `toString` in class `Object`
      Returns:
        A string representation

Copyright © 2016 <code@io7m.com> http://io7m.com